//
// c r t 0 . c
//
// 2nd C runtime startup module contains _setup()
//
// Nov. 26, 2003 by Wataru Nishida (http://www.wnsihida.com)
//

#include "printf.h"
#include "realmode.h"

#define MAX_ARGS 64		// Maximum number of arguments
#define PSP_ARGS ((char*) 0x80)	// DOS arguments will be stored @ PSP:0x80

int argc;			// Argument counter
char* argv[ MAX_ARGS ];		// Argument string pointer holders
char null[] = "";		// Null string for initial argvs

#ifdef DUMPARGS
// Dump arguments in PSP

void dump(void) {
  int i;
  unsigned char* p = PSP_ARGS;

  for (i = 0; i < 32; i++) {
    if ((i % 16) == 00) printf("\n%04x: ", p);
    printf("%02x ", *p++);
   }
  printf("\n");
 }
#endif

// Analyze command line arguments and setup argc, argv[]

int _setup(void) {
  int i, len;
  unsigned char* ptr = PSP_ARGS;
  extern int main(int argc, char** argv);

#ifdef DUMPARGS
  dump();
#endif

  // Clear arguments

  argc = 1;				// PSP does not hold command name
  for (i = 0; i < MAX_ARGS; i++)
    argv[ i ] = null;

  // Analyze and process arguments

  len = (int) *ptr++;			// Read string length
  while (len > 0) {
    while (*ptr == ' ' && len) {	// Skip blanks
      ptr++; len--;			// Forward pointer & decrement counter
     }
    argv[ argc++ ] = ptr;		// Save current argument pointer
    while (*ptr > ' ' && len) {		// Read through argument
      ptr++; len--;			// Forward pointer & decrement counter
     }
    *ptr++ = 0;	len--;			// Terminate with null
   }

#ifdef DUMPARGS
  dump();
#endif

  return( main(argc, argv) );		// Call main()
 }
