//
// o v e r s c a n . c
//
// Change the color of overscan area
//
// Nov. 26, 2003 by Wataru Nishida (http://www.wnishida.com)
//

#include "doslib.h"
#include "printf.h"
#include "vga.h"
#include "realmode.h"

void set_overscan(int pal) {
  // Turn off VGA_ATR_LOCK bit while manipulating palette registers!

  inb(VGA_INPUT_STATUS1);		// Flip-flop input status #1 register
  outb(VGA_ATR_ADDWR,VGA_ATR_OVERSCAN);	// Select overscan color register
  outb(VGA_ATR_ADDWR, pal);		// Update the contents

  // Turn on the VGA_ATR_LOCK bit again, and recover the screen

  inb(VGA_INPUT_STATUS1);		// Flip-flop input status #1 register
  outb(VGA_ATR_ADDWR, VGA_ATR_LOCK);	// Lock the palette and enable screen
 }

int main(int argc, char** argv) {
  int pal;

  if (argc != 2) {
    printf("Usage: overscan palette#\n");
    return 1;
   }

  pal = atoi(argv[ 1 ]);
  set_overscan(pal);			// Change overscan color
  return 0;
 }
