//
// t e x t . h
//
// Include header file for primitive PC/AT VGA text driver
//
// Nov. 25, 2003 by Wataru Nishida (http://www.wnishida.com)
//

#ifndef _TEXT_H_
#define _TEXT_H_

// Constatns

#define TEXT_SEGMENT		0xB800	// VGA text VRAM segment address
#define TEXT_MAX_SCREENS	8	// Maximum number of screens
#define TEXT_DEF_ATTRIBUTE	0x07	// Default attribute code (white)

// Macro definition

#define vram_data(ch, attr)	((attr << 8) + ch)

// Define "screen" structure

typedef struct {
  short* buffer;	// Screen buffer pointer
  int width, height;	// Screen geometry
  int x, y;		// Cursor position
  int cursor;		// Cursor switch (0:off, 1:on)
  int attr;		// Current attribute code
 } screen;

// External variables shared between modules

extern screen scrn[];	// Screen structure
extern int scrn_page;	// Screen page number

// Prototype definitions

void selectpage(int num);
void color(int attr);
void locate(int x, int y);
void scrollup(void);
void clear(void);
void putchar(int ch);

#endif
