//
// x t t y . c
//
// Extended toy TTY program
//
// Dec. 17, 2003 by Wataru Nishida (http://www.wnishida.com)
//

#include "doslib.h"
#include "vga.h"
#include "text.h"
#include "printf.h"
#include "realmode.h"

// Screen definition

#define WIDTH			90		// Screen width
#define HEIGHT			60		// Screen height
#define BUF_SIZE		0x3000		// Size of screen buffer

#undef  TEXT_MAX_SCREENS
#define TEXT_MAX_SCREENS	2		// Number of virtual screens

int main() {
  int add, i, j, cnt = 0, ch;
  extern unsigned char font_8[][];
  extern unsigned char font_16[][];

  // Initialize screen structures

  add = 0x1000;					// Skip default screen area
  for (i = 0; i < TEXT_MAX_SCREENS; i++) {
    scrn[ i ].buffer = (short*) add;
    scrn[ i ].width = WIDTH;
    scrn[ i ].height = HEIGHT;
    scrn[ i ].x = scrn[ i ].y = 0;
    scrn[ i ].cursor = 1;
    scrn[ i ].attr = TEXT_DEF_ATTRIBUTE;
    add += BUF_SIZE;
   }

  // Transfer 8 pixel font data

  memory_mode(MEMORY_FONT);
  xfer_font(0xA000, (unsigned char*) font_8, 32 * 256);
  memory_mode(MEMORY_TEXT);

  // Turn into extended text mode (90x60: Tune up by yourself!)

  htiming(112,90,91,110,100,109,90,8);		// 90 chars, 8 pixels width
  vtiming(525,480,488,517,489,490,480,8);	// 480 lines, 8 pixels height

  // Change cursor shape

  cursor_size(0, 7);

  // Initialize screen contents

  for (i = 0; i < TEXT_MAX_SCREENS; i++) {
    selectpage(i);
    color((i << 4) + 0x0F);
    clear();
    printf("=== This is /dev/xtty%d ===\n", i + 1);
    printf("1.......10");
    for (j = 2; j <= (WIDTH / 10); j++)
      printf("........%02d", j * 10);
    if (WIDTH % 10) {
      for (j = 0; j < (WIDTH % 10); j++)
        printf(".");
     }
   }

  while (1) {
   loop:
    selectpage(cnt);
    memory_start(((int) scrn[ scrn_page ].buffer) / 2);
    cursor_pos(scrn[ scrn_page ].x, scrn[ scrn_page ].y);
    do {
      ch = dos_getchar();
      if (ch < 0)
        continue;
      else if (ch == 27)
        goto end;
      else if (ch == '\t') {
        cnt++;
        if (cnt == TEXT_MAX_SCREENS)
          cnt = 0;
        goto loop;
       }
      else if (ch == '\r')
        putchar('\n');
      else
        putchar(ch);
     } while (1);
   };
 end:
  memory_start(0);

  // Restore default parameters (80x25)

  htiming(100, 80, 81, 98, 90, 97, 80, 9);	// 80 chars, 8 pixels height
  vtiming(449,400,407,441,413,414,400,16);	// 400 lines, 16 pixels height

  // Transfer default 16 pixel font data

  memory_mode(MEMORY_FONT);
  xfer_font(0xA000, (unsigned char*) font_16, 32 * 256);
  memory_mode(MEMORY_TEXT);

  return 0;
 }
